    001    /*
    002     * Copyright (c) 2007-2014 Concurrent, Inc. All Rights Reserved.
    003     *
    004     * Project and contact information: http://www.cascading.org/
    005     *
    006     * This file is part of the Cascading project.
    007     *
    008     * Licensed under the Apache License, Version 2.0 (the "License");
    009     * you may not use this file except in compliance with the License.
    010     * You may obtain a copy of the License at
    011     *
    012     *     http://www.apache.org/licenses/LICENSE-2.0
    013     *
    014     * Unless required by applicable law or agreed to in writing, software
    015     * distributed under the License is distributed on an "AS IS" BASIS,
    016     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    017     * See the License for the specific language governing permissions and
    018     * limitations under the License.
    019     */
    020
    021    package cascading.operation;
    022
    023    import cascading.flow.FlowProcess;
    024
    025    /**
    026     * Interface Function marks a given {@link Operation} as a function, as opposed to being a {@link Filter}.
    027     * <p/>
    028     * A Function is responsible for taking Tuple arguments and returning one or more result Tuples.
    029     * <p/>
    030     * To implement a Function, (optionally) sub-class {@link BaseOperation} and have the new sub-class {@code implement}
    031     * this interface.
    032     */
    033    public interface Function<Context> extends Operation<Context>
    034      {
    035      /**
    036       * Method operate provides the implementation of this Function.
    037       *
    038       * @param flowProcess  of type FlowProcess
    039       * @param functionCall of type FunctionCall
    040       */
    041      void operate( FlowProcess flowProcess, FunctionCall<Context> functionCall );
    042      }